# -*- coding: utf-8 -*-
"""
Created on Sat Aug 29 19:23:56 2015

@author: Ricco
"""

import numpy as np
import scipy.stats as stat
import scipy.cluster as cluster

import os
os.chdir("D:/_Travaux/university/Cours_Universite/Supports_de_cours/Informatique/Python/Slides/exemples/I")

#matrice de données
M = np.loadtxt("datacluster.txt",delimiter="\t",dtype=float)
np.std(M,axis=0)

#plot - graphique nuage de points
import matplotlib.pyplot as plt
plt.plot(M[:,0],M[:,1],"ko")

#centrer et réduire
#axis=0, calcul des moyenne/variance des lignes pour chaque col.
#ddof = 0, utiliser 1/(n-0) pour le calcul de la variance
Z = stat.zscore(M,axis=0,ddof=0)
np.std(Z,axis=0)

#k-means en 3 groupes
centroid,label = cluster.vq.kmeans2(Z,k=3)
#barycentres conditionnels
print(centroid)
#id des groupes pour chaque individu
print(label)

#graphique de nouveau
plt.plot(M[label==0,0],M[label==0,1],"bo",
         M[label==1,0],M[label==1,1],"ro",
         M[label==2,0],M[label==2,1],"go")
        
#CAH

#dendrogramme - méthode de Ward
W = cluster.hierarchy.ward(Z)

#affichage du dendrogramme
cluster.hierarchy.dendrogram(W)

#découpage
idx = cluster.hierarchy.fcluster(W,t=4,criterion="distance")

#graphique again
plt.plot(M[idx==1,0],M[idx==1,1],"bo",
         M[idx==2,0],M[idx==2,1],"ro",
         M[idx==3,0],M[idx==3,1],"go")
         